`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    22:58:17 08/31/2009 
// Design Name: 
// Module Name:    StateMachineWorld 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module StateMachineWorld(
    input BTN1,
    input BTN2,
    input BTN3,
    input CLK,
    input RESET,
    output [2:0] STATE_OUT
    );

reg [2:0] Current_State;
reg [2:0] Next_State;

assign STATE_OUT = Current_State;

always@(posedge CLK) begin
		if(RESET) 
			Current_State <= 3'b000;
		else
			Current_State <= Next_State;
end

always@(Current_State or BTN1 or BTN2 or BTN3)

	case (Current_State)
	
		3'b000 : begin
			if(BTN2)
				Next_State <= 3'b110;
			else
				Next_State <= Current_State;
		end
	
		3'b001 : begin
			if(BTN2)
				Next_State <= 3'b010;
			else if(BTN1)
				Next_State <= 3'b101;
				else
				Next_State <= Current_State;
		end
	
		3'b010 : begin
			if(BTN2)
				Next_State <= 3'b001;
			else if(BTN1)
				Next_State <= 3'b000;
				else
				Next_State <= Current_State;
		end

		3'b011 : begin
			if(BTN1)
				Next_State <= 3'b100;
			else if(BTN3)
				Next_State <= 3'b010;
				else
				Next_State <= Current_State;
		end

		3'b100 : begin
			if(BTN2)
				Next_State <= 3'b110;
			else if(BTN3)
				Next_State <= 3'b111;
				else
				Next_State <= Current_State;
		end

		3'b101 : begin
			if(BTN2)
				Next_State <= 3'b011;
			else if(BTN3)
				Next_State <= 3'b000;
				else
				Next_State <= Current_State;
		end

		3'b110 : begin
			if(BTN2)
				Next_State <= 3'b001;
			else if(BTN3)
				Next_State <= 3'b010;
				else
				Next_State <= Current_State;
		end

		3'b111 : Next_State <= Current_State;
		
		default : Next_State <= 3'b000;

	
	endcase



endmodule
